/*

Copyright (C) 2003 J.D. Cole <jd@transientresearch.com>

This file is part of Octave.

Octave is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2, or (at your option) any
later version.

Octave is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Octave; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

$Id: oct-pil.h,v 1.4.2.1 2003/03/03 22:23:58 jd Exp $
*/

#if !defined (octave_parallel_interface_library_h)
#define octave_parallel_interface_library_h 1

#if defined (__GNUG__) && defined (USE_PRAGMA_INTERFACE_IMPLEMENTATION)
#pragma interface
#endif

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "defun-int.h"
#include "ov-builtin.h"

#define PIL_INSTALL_BUILTIN_FUN(name, doc) \
  install_builtin_function (name, #name, doc)

extern "C"
{
  enum pi_error
  {
    no_error,
    failed
  };

  typedef pi_error (*pil_initialize_fcn_type)(int *argc, char **argv[]);
  typedef pi_error (*pil_install_builtins_fcn_type)(void);
  typedef pi_error (*pil_finalize_fcn_type)(void);

  typedef char *(*pil_error_string_fcn_type)(void);

  pi_error pil_initialize (int *argc, char **argv[]);

  pi_error pil_install_builtins (void);

  pi_error pil_finalize (void);

  char *pil_error_string (void);
}

#endif

/*
;;; Local Variables: ***
;;; mode: C++ ***
;;; End: ***
*/
